diff --git a/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java b/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
index c17c11533..f7e47a5ca 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
@@ -2,17 +2,17 @@ package net.minecraft.core.entity;
 
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
 
 import java.util.List;
 
-public abstract class MobPathfinder extends Mob
-{
+public abstract class MobPathfinder extends Mob {
     private static final int MAX_TURN = 30;
     protected @Nullable Path pathToEntity;
     protected @Nullable Entity target;
@@ -20,142 +20,118 @@ public abstract class MobPathfinder extends Mob
     protected boolean hasAttacked;
     protected boolean doRandomWalk = true;
 
-    public MobPathfinder(@NotNull final World world)
-    {
+    public MobPathfinder(@NotNull final World world) {
         super(world);
-        hasAttacked = false;
+        this.hasAttacked = false;
     }
 
-    protected boolean isMovementCeased()
-    {
+    protected boolean isMovementCeased() {
         return false;
     }
 
     @Override
-	protected void updateAI()
-    {
-        hasAttacked = isMovementCeased();
+    protected void updateAI() {
+        this.hasAttacked = isMovementCeased();
         float sightRadius = 16F;
-        if(target == null)
-        {
-            target = findPlayerToAttack();
-            if(target != null)
-            {
-                pathToEntity = world.getPathToEntity(this, target, sightRadius);
+        if (this.target == null) {
+            this.target = findPlayerToAttack();
+            if (this.target != null) {
+                this.pathToEntity = this.world.getPathToEntity(this, this.target, sightRadius);
             }
-        }
-        else if(!target.isAlive())
-        {
-            target = null;
-        }
-        else
-        {
-            float distanceToEntity = target.distanceTo(this);
-            if(canEntityBeSeen(target))
-            {
-                attackEntity(target, distanceToEntity);
-            } else
-            {
-                attackBlockedEntity(target, distanceToEntity);
+        } else if (!this.target.isAlive()) {
+            this.target = null;
+        } else {
+            float distanceToEntity = this.target.distanceTo(this);
+            if (canEntityBeSeen(this.target)) {
+                attackEntity(this.target, distanceToEntity);
+            } else {
+                attackBlockedEntity(this.target, distanceToEntity);
             }
         }
-        if(this.doRandomWalk && (!hasAttacked && target != null && (pathToEntity == null || random.nextInt(20) == 0)))
-        {
+        if (this.doRandomWalk && (!this.hasAttacked && this.target != null && (this.pathToEntity == null || this.random.nextInt(20) == 0))) {
             //pathfind to entity
-            pathToEntity = world.getPathToEntity(this, target, sightRadius);
-        } else
-        if(this.doRandomWalk && (!hasAttacked && closestFireflyEntity == null && (pathToEntity == null && random.nextInt(80) == 0 || random.nextInt(80) == 0)))
-        {
+            this.pathToEntity = this.world.getPathToEntity(this, this.target, sightRadius);
+        } else if (this.doRandomWalk && (!this.hasAttacked && this.closestFireflyEntity == null && (this.pathToEntity == null && this.random.nextInt(80) == 0 || this.random.nextInt(80) == 0))) {
             // random roaming
             roamRandomPath();
         }
-        int i = MathHelper.floor(bb.minY + 0.5D);
+        int i = MathHelper.floor(this.bb.minY + 0.5D);
         boolean inWater = isInWater();
         boolean inLava = isInLava();
-        xRot = 0.0F;
-        if(pathToEntity == null || (this.doRandomWalk && random.nextInt(100) == 0))
-        {
+        this.xRot = 0.0F;
+        if (this.pathToEntity == null || (this.doRandomWalk && this.random.nextInt(100) == 0)) {
             super.updateAI();
-            pathToEntity = null;
+            this.pathToEntity = null;
             return;
         }
-        Vec3 coordsForNextPath = pathToEntity.getPos(this);
-        for(double d = bbWidth * 2.0F; coordsForNextPath != null && coordsForNextPath.distanceToSquared(x, coordsForNextPath.y, z) < d * d;)
-        {
-            pathToEntity.next();
-            if(pathToEntity.isDone())
-            {
-                closestFireflyEntity = null;
+        Vector3dc coordsForNextPath = this.pathToEntity.getPos(this);
+        for (double d = this.bbWidth * 2.0F; coordsForNextPath != null && coordsForNextPath.distanceSquared(this.x, coordsForNextPath.y(), this.z) < d * d; ) {
+            this.pathToEntity.next();
+            if (this.pathToEntity.isDone()) {
+                this.closestFireflyEntity = null;
                 coordsForNextPath = null;
-                pathToEntity = null;
-            } else
-            {
-                coordsForNextPath = pathToEntity.getPos(this);
+                this.pathToEntity = null;
+            } else {
+                coordsForNextPath = this.pathToEntity.getPos(this);
             }
         }
 
-        isJumping = false;
-        if(coordsForNextPath != null)
-        {
-            double x1 = coordsForNextPath.x - x;
-            double z1 = coordsForNextPath.z - z;
-            double y1 = coordsForNextPath.y - (double)i;
-            float f2 = (float)((java.lang.Math.atan2(z1, x1) * 180D) / Math.PI) - 90F;
-            float f3 = f2 - yRot;
+        this.isJumping = false;
+        if (coordsForNextPath != null) {
+            double x1 = coordsForNextPath.x() - this.x;
+            double z1 = coordsForNextPath.z() - this.z;
+            double y1 = coordsForNextPath.y() - (double) i;
+            float f2 = (float) ((java.lang.Math.atan2(z1, x1) * 180D) / Math.PI) - 90F;
+            float f3 = f2 - this.yRot;
 
             //move forward towards path
-            moveForward = moveSpeed;
-            for(; f3 < -180F; f3 += 360F) { }
-            for(; f3 >= 180F; f3 -= 360F) { }
-            if(f3 > MAX_TURN)
-            {
+            this.moveForward = this.moveSpeed;
+            for (; f3 < -180F; f3 += 360F) {
+            }
+            for (; f3 >= 180F; f3 -= 360F) {
+            }
+            if (f3 > MAX_TURN) {
                 f3 = MAX_TURN;
             }
-            if(f3 < -MAX_TURN)
-            {
+            if (f3 < -MAX_TURN) {
                 f3 = -MAX_TURN;
             }
-            yRot += f3;
-            if(hasAttacked && target != null)
-            {
-                double d4 = target.x - x;
-                double d5 = target.z - z;
-                float f5 = yRot;
-                yRot = (float)((java.lang.Math.atan2(d5, d4) * 180D) / Math.PI) - 90F;
-                float f4 = (((f5 - yRot) + 90F) * MathHelper.PI) / 180F;
-                moveStrafing = -MathHelper.sin(f4) * moveForward * 1.0F;
-                moveForward = MathHelper.cos(f4) * moveForward * 1.0F;
+            this.yRot += f3;
+            if (this.hasAttacked && this.target != null) {
+                double d4 = this.target.x - this.x;
+                double d5 = this.target.z - this.z;
+                float f5 = this.yRot;
+                this.yRot = (float) ((java.lang.Math.atan2(d5, d4) * 180D) / Math.PI) - 90F;
+                float f4 = (((f5 - this.yRot) + 90F) * MathHelper.PI) / 180F;
+                this.moveStrafing = -MathHelper.sin(f4) * this.moveForward * 1.0F;
+                this.moveForward = MathHelper.cos(f4) * this.moveForward * 1.0F;
             }
-            if(y1 > 0.0D)
-            {
-                isJumping = true;
+            if (y1 > 0.0D) {
+                this.isJumping = true;
             }
         }
-        if(target != null)
-        {
-            lookAt(target, 30F, 30F);
+        if (this.target != null) {
+            lookAt(this.target, 30F, 30F);
         }
-        if(horizontalCollision && !hasPath())
-        {
-            isJumping = true;
+        if (this.horizontalCollision && !hasPath()) {
+            this.isJumping = true;
         }
-        if(random.nextFloat() < 0.8F && (inWater || inLava))
-        {
-            isJumping = true;
+        if (this.random.nextFloat() < 0.8F && (inWater || inLava)) {
+            this.isJumping = true;
         }
     }
 
-    protected @Nullable Entity getClosestFireflyToEntity (int x, int y, int z, float radius){
-        List<MobFireflyCluster> nearbyFireflies = world.getEntitiesWithinAABB(MobFireflyCluster.class, AABB.fromPool(this.x, this.y, this.z, this.x + 1.0D, this.y + 1.0D, this.z + 1.0D).grow(radius, 4D, radius));
+    protected @Nullable Entity getClosestFireflyToEntity(int x, int y, int z, float radius) {
+        AABBd bb = new AABBd(this.x, this.y, this.z, this.x + 1.0D, this.y + 1.0D, this.z + 1.0D);
+        MathHelper.aabbGrow(bb, radius, 4D, radius, bb);
+        List<MobFireflyCluster> nearbyFireflies = this.world.getEntitiesWithinAABB(MobFireflyCluster.class, bb);
 
         double closestDistance = -1D;
         MobFireflyCluster cluster = null;
-        for(int i = 0; i < nearbyFireflies.size(); i++)
-        {
+        for (int i = 0; i < nearbyFireflies.size(); i++) {
             MobFireflyCluster clusterInList = nearbyFireflies.get(i);
             double currentDistance = clusterInList.distanceToSqr(x, y, z);
-            if((radius < 0.0D || currentDistance < radius * radius) && (closestDistance == -1D || currentDistance < closestDistance))
-            {
+            if ((radius < 0.0D || currentDistance < radius * radius) && (closestDistance == -1D || currentDistance < closestDistance)) {
                 closestDistance = currentDistance;
                 cluster = clusterInList;
             }
@@ -163,79 +139,64 @@ public abstract class MobPathfinder extends Mob
         return cluster;
     }
 
-    protected void roamRandomPath()
-    {
-        boolean canMoveToPoint = false;
-        int x = -1;
-        int y = -1;
-        int z = -1;
+    protected void roamRandomPath() {
+        TilePos tilePos = null;
         float bestPathWeight = -99999F;
-        for(int l = 0; l < 10; l++)
-        {
-            int x1 = MathHelper.floor((this.x + (double) random.nextInt(13)) - 6D);
-            int y1 = MathHelper.floor((this.y + (double) random.nextInt(7)) - 3D);
-            int z1 = MathHelper.floor((this.z + (double) random.nextInt(13)) - 6D);
+        for (int l = 0; l < 10; l++) {
+            int x1 = MathHelper.floor((this.x + (double) this.random.nextInt(13)) - 6D);
+            int y1 = MathHelper.floor((this.y + (double) this.random.nextInt(7)) - 3D);
+            int z1 = MathHelper.floor((this.z + (double) this.random.nextInt(13)) - 6D);
             float currentPathWeight = getBlockPathWeight(x1, y1, z1);
-            if(currentPathWeight > bestPathWeight)
-            {
+            if (currentPathWeight > bestPathWeight) {
                 bestPathWeight = currentPathWeight;
-                x = x1;
-                y = y1;
-                z = z1;
-                canMoveToPoint = true;
+                if (tilePos != null) {
+                    tilePos.set(x1, y1, z1);
+                } else {
+                    tilePos = new TilePos(x1, y1, z1);
+                }
             }
         }
 
-        if(canMoveToPoint)
-        {
-            pathToEntity = world.getEntityPathToXYZ(this, x, y, z, 10F);
+        if (tilePos != null) {
+            this.pathToEntity = this.world.getEntityPathToTilePos(this, tilePos, 10F);
         }
     }
 
-    protected void attackEntity(@NotNull Entity entity, float distance)
-    {
+    protected void attackEntity(@NotNull Entity entity, float distance) {
     }
 
-    protected void attackBlockedEntity(@NotNull Entity entity, float f)
-    {
+    protected void attackBlockedEntity(@NotNull Entity entity, float f) {
     }
 
-    protected float getBlockPathWeight(int x, int y, int z)
-    {
+    protected float getBlockPathWeight(int x, int y, int z) {
         return 0.0F;
     }
 
-    protected Entity findPlayerToAttack()
-    {
+    protected Entity findPlayerToAttack() {
         return null;
     }
 
     @Override
-	public boolean canSpawnHere()
-    {
+    public boolean canSpawnHere() {
         int x = MathHelper.floor(this.x);
-        int y = MathHelper.floor(bb.minY);
+        int y = MathHelper.floor(this.bb.minY);
         int z = MathHelper.floor(this.z);
         return super.canSpawnHere() && getBlockPathWeight(x, y, z) >= 0.0F;
     }
 
-    public boolean hasPath()
-    {
-        return pathToEntity != null;
+    public boolean hasPath() {
+        return this.pathToEntity != null;
     }
 
-    public void setPathToEntity(@Nullable Path path)
-    {
-        pathToEntity = path;
+    public void setPathToEntity(@Nullable Path path) {
+        this.pathToEntity = path;
     }
 
-    public @Nullable Entity getTarget()
-    {
-        return target;
+    public @Nullable Entity getTarget() {
+        return this.target;
     }
 
-    public void setTarget(@Nullable Entity target)
-    {
+    public void setTarget(@Nullable Entity target) {
         this.target = target;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/SpawnListEntry.java b/game/core/src/main/java/net/minecraft/core/entity/SpawnListEntry.java
index 103df3edd..4b8b1e77b 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/SpawnListEntry.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/SpawnListEntry.java
@@ -1,15 +1,14 @@
 package net.minecraft.core.entity;
 
 
-public class SpawnListEntry
-{
+import org.jetbrains.annotations.NotNull;
 
-    public SpawnListEntry(Class<? extends Entity> clazz, int frequency)
-    {
-        entityClass = clazz;
-        spawnFrequency = frequency;
-    }
-
-    public Class<? extends Entity> entityClass;
+public class SpawnListEntry {
+    public @NotNull Class<? extends Entity> entityClass;
     public int spawnFrequency;
+
+    public SpawnListEntry(final @NotNull Class<? extends Entity> clazz, final int frequency) {
+        this.entityClass = clazz;
+        this.spawnFrequency = frequency;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
index 26e40d478..a38227e25 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
@@ -14,19 +14,16 @@ import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
 
 import java.util.Arrays;
-import java.util.HashMap;
 import java.util.HashSet;
-import java.util.Map;
 import java.util.Set;
 import java.util.function.Supplier;
 
@@ -40,7 +37,7 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
     public static final ButterflyEntry COLOR_PINK;
     public static final ButterflyEntry COLOR_SILVER;
 
-    public static ButterflyEntry addEntry(int id, String name, double weight, Supplier<Item> jarItem, Biome ... allowedBiomes) {
+    public static ButterflyEntry addEntry(int id, String name, double weight, Supplier<Item> jarItem, Biome... allowedBiomes) {
         assert id >= 0 && id <= 0xFF : "ID is outside valid range!";
         ButterflyEntry entry = new ButterflyEntry(id, name, weight, jarItem, allowedBiomes);
         colorEntries.put(id, entry);
@@ -68,12 +65,11 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
     @Override
     protected void defineSynchedData() {
         super.defineSynchedData();
-        entityData.define(DATA_COLOR_ID, (byte)0, Byte.class);
+        this.entityData.define(DATA_COLOR_ID, (byte) 0, Byte.class);
     }
 
     @Override
-    protected boolean makeStepSound()
-    {
+    protected boolean makeStepSound() {
         return false;
     }
 
@@ -93,20 +89,17 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
     }
 
     @Override
-    public String getLivingSound()
-    {
+    public String getLivingSound() {
         return "";
     }
 
     @Override
-    protected String getHurtSound()
-    {
+    protected String getHurtSound() {
         return "";
     }
 
     @Override
-    protected String getDeathSound()
-    {
+    protected String getDeathSound() {
         return "";
     }
 
@@ -120,8 +113,7 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
     }
 
     @Override
-    public boolean hurt(Entity attacker, int i, DamageType type)
-    {
+    public boolean hurt(Entity attacker, int i, DamageType type) {
         if (type == null || type == DamageType.GENERIC || type == DamageType.BLAST || type == DamageType.FIRE || type == DamageType.DROWN) {
             return super.hurt(attacker, i, type);
         }
@@ -133,7 +125,7 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
     public void spawnInit() {
         super.spawnInit();
 
-        Biome currentBiome = world.getBlockBiome(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
+        Biome currentBiome = this.world.getBlockBiome(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z));
 
         WeightedRandomBag<ButterflyEntry> colorBag = new WeightedRandomBag<>();
         for (ButterflyEntry entry : colorEntries.values()) {
@@ -148,32 +140,27 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
     }
 
     @Override
-    public boolean canSpawnHere()
-    {
-        if (!world.isDaytime()) return false;
+    public boolean canSpawnHere() {
+        if (!this.world.isDaytime()) return false;
         int x = MathHelper.floor(this.x);
-        int y = MathHelper.floor(bb.minY);
+        int y = MathHelper.floor(this.bb.minY);
         int z = MathHelper.floor(this.z);
-        int id = world.getBlockId(x, y - 1, z);
-        if (Blocks.blocksList[id] != null)
-        {
-            return Blocks.blocksList[id].hasTag(BlockTags.PASSIVE_MOBS_SPAWN) && world.getFullBlockLightValue(x, y, z) > 8 && super.canSpawnHere();
+        int id = this.world.getBlockId(x, y - 1, z);
+        if (Blocks.blocksList[id] != null) {
+            return Blocks.blocksList[id].hasTag(BlockTags.PASSIVE_MOBS_SPAWN) && this.world.getFullBlockLightValue(x, y, z) > 8 && super.canSpawnHere();
         }
         return false;
     }
 
-    private boolean isCourseTraversable(double waypointX, double waypointY, double waypointZ, double distanceFromEntity)
-    {
-
-        double dx = (waypointX - x) / distanceFromEntity;
-        double dy = (waypointY - y) / distanceFromEntity;
-        double dz = (waypointZ - z) / distanceFromEntity;
-        AABB entityBB = bb.copy();
-        for(int i = 0; (double)i < distanceFromEntity; i++)
-        {
-            entityBB.move(dx, dy, dz);
-            if(!world.getCubes(this, entityBB).isEmpty())
-            {
+    private boolean isCourseTraversable(double waypointX, double waypointY, double waypointZ, double distanceFromEntity) {
+
+        double dx = (waypointX - this.x) / distanceFromEntity;
+        double dy = (waypointY - this.y) / distanceFromEntity;
+        double dz = (waypointZ - this.z) / distanceFromEntity;
+        AABBd entityBB = new AABBd(this.bb);
+        for (int i = 0; (double) i < distanceFromEntity; i++) {
+            entityBB.translate(dx, dy, dz);
+            if (!this.world.getCubes(this, entityBB).isEmpty()) {
                 return false;
             }
         }
@@ -182,65 +169,64 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
     }
 
     @Override
-    protected void updateAI()
-    {
-        entityAge++;
+    protected void updateAI() {
+        this.entityAge++;
         tryToDespawn();
 
-        Player closestPlayer = world.getClosestPlayerToEntity(this, 2);
+        Player closestPlayer = this.world.getClosestPlayerToEntity(this, 2);
         if (closestPlayer != null) {
-            double distanceX = closestPlayer.x - x;
+            double distanceX = closestPlayer.x - this.x;
 //            double distanceY = closestPlayer.y - y;
-            double distanceZ = closestPlayer.z - z;
+            double distanceZ = closestPlayer.z - this.z;
 
             double distance = Math.hypot(distanceX, distanceZ);
 
-            waypointX = x + (distanceX / distance) * -5;
-            waypointY = y + 4;
-            waypointZ = z + (distanceZ / distance) * -5;
+            this.waypointX = this.x + (distanceX / distance) * -5;
+            this.waypointY = this.y + 4;
+            this.waypointZ = this.z + (distanceZ / distance) * -5;
         }
 
-        double distanceX = waypointX - x;
-        double distanceY = waypointY - y;
-        double distanceZ = waypointZ - z;
+        double distanceX = this.waypointX - this.x;
+        double distanceY = this.waypointY - this.y;
+        double distanceZ = this.waypointZ - this.z;
 
         double distanceFromEntity = MathHelper.sqrt(distanceX * distanceX + distanceY * distanceY + distanceZ * distanceZ);
 
         if (distanceFromEntity > 32) {
-            waypointX = x;
-            waypointY = y;
-            waypointZ = z;
+            this.waypointX = this.x;
+            this.waypointY = this.y;
+            this.waypointZ = this.z;
             return;
         }
 
         if (distanceFromEntity > 1D) {
-            xd += (distanceX / distanceFromEntity) * 0.01D;
-            yd += (distanceY / distanceFromEntity) * 0.01D;
-            zd += (distanceZ / distanceFromEntity) * 0.01D;
-            yRot = (float) ((Math.atan2(xd, zd) * 180F) / MathHelper.PI);
+            this.xd += (distanceX / distanceFromEntity) * 0.01D;
+            this.yd += (distanceY / distanceFromEntity) * 0.01D;
+            this.zd += (distanceZ / distanceFromEntity) * 0.01D;
+            this.yRot = (float) ((Math.atan2(this.xd, this.zd) * 180F) / MathHelper.PI);
         }
 
-        if(courseChangeCooldown-- <= 0) {
-            courseChangeCooldown += random.nextInt(40) + 20;
-            if (!(distanceFromEntity > 1D) || !isCourseTraversable(waypointX, waypointY, waypointZ, distanceFromEntity)) {
-                double nextX = x + (double) ((random.nextFloat() * 2.0F - 1.0F) * 16F);
-                double nextY = y + (double) ((random.nextFloat() * 2.0F - 1.0F) * 5F);
-                double nextZ = z + (double) ((random.nextFloat() * 2.0F - 1.0F) * 16F);
+        if (this.courseChangeCooldown-- <= 0) {
+            this.courseChangeCooldown += this.random.nextInt(40) + 20;
+            if (!(distanceFromEntity > 1D) || !isCourseTraversable(this.waypointX, this.waypointY, this.waypointZ, distanceFromEntity)) {
+                double nextX = this.x + (double) ((this.random.nextFloat() * 2.0F - 1.0F) * 16F);
+                double nextY = this.y + (double) ((this.random.nextFloat() * 2.0F - 1.0F) * 5F);
+                double nextZ = this.z + (double) ((this.random.nextFloat() * 2.0F - 1.0F) * 16F);
 
-                if (nextY > y) {
+                if (nextY > this.y) {
                     if (isUpwardWaypointValid(MathHelper.floor(nextX), MathHelper.floor(nextY), MathHelper.floor(nextZ))) {
-                        waypointX = nextX;
-                        waypointY = nextY;
-                        waypointZ = nextZ;
+                        this.waypointX = nextX;
+                        this.waypointY = nextY;
+                        this.waypointZ = nextZ;
                     } else {
-                        waypointX = x;
-                        waypointY = y;
-                        waypointZ = z;
+                        this.waypointX = this.x;
+                        this.waypointY = this.y;
+                        this.waypointZ = this.z;
                     }
                 } else {
-                    waypointX = nextX;
-                    waypointY = nextY;
-                    waypointZ = nextZ;
+                    this.waypointX = nextX;
+                    this.waypointY = nextY;
+                    this.waypointZ = nextZ;
                 }
             } /*else {
                 xd += (distanceX / distanceFromEntity) * 0.1D;
@@ -254,7 +240,7 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
     public boolean isUpwardWaypointValid(int x, int y, int z) {
         final byte range = 3;
         for (int _y = y; _y > y - range; _y--) {
-            Block<?> block = world.getBlock(x, _y, z);
+            Block<?> block = this.world.getBlock(x, _y, z);
             if (block == null/* || !block.hasTag(BlockTags.PASSIVE_MOBS_SPAWN)*/) continue;
             return true;
         }
@@ -262,12 +248,12 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
     }
 
     public int getColor() {
-        return entityData.getByte(DATA_COLOR_ID) & 0xFF;
+        return this.entityData.getByte(DATA_COLOR_ID) & 0xFF;
     }
 
     public void setColor(int color) {
         assert color >= 0 && color <= 0xFF : "Color is outside valid range!";
-        entityData.set(DATA_COLOR_ID, (byte)color);
+        this.entityData.set(DATA_COLOR_ID, (byte) color);
     }
 
     @Override
@@ -295,7 +281,7 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
     @Override
     public String getTextureReference() {
         final SkinVariantList variantList = Global.accessor.getSkinVariantList();
-        return colorEntries.get(getColor()).name + "/" + variantList.getSkinReference(variantJsonPath, "0", getSkinVariant());
+        return colorEntries.get(getColor()).name + "/" + variantList.getSkinReference(this.variantJsonPath, "0", getSkinVariant());
     }
 
     public static class ButterflyEntry {
@@ -306,7 +292,7 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
         public final Supplier<Item> jarItem;
         public final double weight;
 
-        public ButterflyEntry(int id, String name, double weight, Supplier<Item> jarItem, Biome ... allowedBiomes) {
+        public ButterflyEntry(int id, String name, double weight, Supplier<Item> jarItem, Biome... allowedBiomes) {
             this.id = id;
             this.name = name;
             this.weight = weight;
@@ -319,13 +305,13 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
         }
 
         public ButterflyEntry addAllowedBiome(Biome biome) {
-            if (allowedBiomes == null) allowedBiomes = new HashSet<>();
+            if (this.allowedBiomes == null) this.allowedBiomes = new HashSet<>();
             this.allowedBiomes.add(biome);
             return this;
         }
 
         public ButterflyEntry removeAllowedBiome(Biome biome) {
-            if (allowedBiomes == null) allowedBiomes = new HashSet<>();
+            if (this.allowedBiomes == null) this.allowedBiomes = new HashSet<>();
             this.allowedBiomes.remove(biome);
             return this;
         }
@@ -336,7 +322,7 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
         }
 
         public boolean isBiomeAllowed(Biome biome) {
-            return allowedBiomes == null || allowedBiomes.contains(biome);
+            return this.allowedBiomes == null || this.allowedBiomes.contains(biome);
         }
     }
 }
